#!/usr/bin/env python

# Wat execution script.
# Copyright (C) 2021 Ariel Ortiz, ITESM CEM

from wasmer import engine, Module, wat2wasm, Store, Instance
from wasmer import ImportObject, Function
from wasmer_compiler_cranelift import Compiler

VALUES = [
  'piedra', # 0
  'papel',  # 1
  'tijeras' # 2
]

def make_import_object(store):

    def mas(a: int, b: int) -> int:
      if a == b:
        return a
      if a == 0:
        return a if b == 2 else b
      if a == 1:
        return a if b == 0 else b
      if a == 2:
        return a if b == 1 else b
      raise Exception(f"Valores inválidos en 'mas': {a}, {b}")

    def menos(a: int, b: int) -> int:
      if a == b:
        return a
      if a == 0:
        return b if b == 2 else a
      if a == 1:
        return b if b == 0 else a
      if a == 2:
        return b if b == 1 else a
      raise Exception(f"Valores inválidos en 'mas': {a}, {b}")

    import_object = ImportObject()

    import_object.register(
        "ppt",
        {
            "mas": Function(store, mas),
            "menos": Function(store, menos)
        }
    )

    return import_object

def create_instance(file_name):
    store = Store(engine.JIT(Compiler))
    with open(file_name) as wat_file:
        wat_source_code = wat_file.read()
    module = Module(store, wat2wasm(wat_source_code))
    import_object = make_import_object(store)
    return Instance(module, import_object)

def main():
    instance = create_instance('output.wat')
    print(VALUES[instance.exports.inicio()])

main()
